VirtualBox Main API

Public Attributes | List of all members
IUSBDevice Interface Reference

The IUSBDevice interface represents a virtual USB device attached to the virtual machine. More...

Inheritance diagram for IUSBDevice:

## Public Attributes
readonly attribute wstringUUID | id
| Unique USB device ID.
readonly attribute unsigned short | vendorId
| Vendor ID.
readonly attribute unsigned short | productId
| Product ID.
readonly attribute unsigned short | revision
| Product revision number.
readonly attribute wstring | manufacturer
| Manufacturer string.
readonly attribute wstring | product
| Product string.
readonly attribute wstring | serialNumber
| Serial number string.
readonly attribute wstring | address
| Host-specific address of the device, uniquely identifying a physically connected device in the system.
readonly attribute unsigned short | port
| Host USB port number on the hub the device is physically connected to.
readonly attribute wstring | portPath
| Host-specific identifier of the port (including hub) the USB device is physically connected to.
readonly attribute unsigned short | version
| The major USB version of the device - 1, 2 or 3.
readonly attribute USBConnectionSpeed | speed
| The speed at which the device is currently communicating.
readonly attribute boolean | remote
| Whether the device is physically connected to a remote VRDE client or to a local host machine.
readonly attribute wstring[] | deviceInfo
| Array of device attributes as single strings.
readonly attribute wstring | backend
| The backend which will be used to communicate with this device.

## Detailed Description

The IUSBDevice interface represents a virtual USB device attached to the virtual machine.

A collection of objects implementing this interface is stored in the IConsole::USBDevices attribute which lists all USB devices attached to a running virtual machine's USB controller.

Interface ID:
  `{6DC83C2C-81A9-4005-9D52-FC45A78BF3F5}`

## Member Data Documentation

## ◆ id

readonly attribute wstringUUID IUSBDevice::id

Unique USB device ID.

This ID is built from vendorId, productId, revision and serialNumber.

## ◆ vendorId

readonly attribute unsigned short IUSBDevice::vendorId

Vendor ID.

## ◆ productId

readonly attribute unsigned short IUSBDevice::productId

Product ID.

## ◆ revision

readonly attribute unsigned short IUSBDevice::revision

Product revision number.

This is a packed BCD represented as unsigned short. The high byte is the integer part and the low byte is the decimal.

## ◆ manufacturer

readonly attribute wstring IUSBDevice::manufacturer

Manufacturer string.

## ◆ product

readonly attribute wstring IUSBDevice::product

Product string.

## ◆ serialNumber

readonly attribute wstring IUSBDevice::serialNumber

Serial number string.

## ◆ address

readonly attribute wstring IUSBDevice::address

Host-specific address of the device, uniquely identifying a physically connected device in the system.

Note that the address of a USB device may change across device re-plugs and host suspend/resume cycles or reboots.

## ◆ port

readonly attribute unsigned short IUSBDevice::port

Host USB port number on the hub the device is physically connected to.

## ◆ portPath

readonly attribute wstring IUSBDevice::portPath

Host-specific identifier of the port (including hub) the USB device is physically connected to.

Note that hubs may be dynamically added and removed, and that hub enumeration may not be consistent across host reboots.

## ◆ version

readonly attribute unsigned short IUSBDevice::version

The major USB version of the device - 1, 2 or 3.

## ◆ speed

readonly attribute USBConnectionSpeed IUSBDevice::speed

The speed at which the device is currently communicating.

## ◆ remote

readonly attribute boolean IUSBDevice::remote

Whether the device is physically connected to a remote VRDE client or to a local host machine.

## ◆ deviceInfo

readonly attribute wstring [] IUSBDevice::deviceInfo

Array of device attributes as single strings.

So far the following are used: 0: The manufacturer string, if the device doesn't expose the ID one is taken from an internal database or an empty string if none is found. 1: The product string, if the device doesn't expose the ID one is taken from an internal database or an empty string if none is found.

## ◆ backend

readonly attribute wstring IUSBDevice::backend

The backend which will be used to communicate with this device.